Index: build.xml
===================================================================
RCS file: /cvs/dirsec/console/build.xml,v
retrieving revision 1.1.1.1
diff -u -r1.1.1.1 build.xml
--- build.xml	18 Jul 2005 00:34:05 -0000	1.1.1.1
+++ build.xml	12 Oct 2005 20:25:01 -0000
@@ -34,8 +34,8 @@
   <property name="javadoc.dir"     value="${built.dir}/doc"/>
   <property name="imports.dir"     value="${consolesdk.root}/imports"/>
   <property name="java.src.dir"    value="src"/>
-
-  <!-- Prepare -->
+  <property environment="env"/>
+<!-- Prepare -->
   <target name="prepare_build">
     <!-- Create directories -->
     <mkdir dir="${built.classdir}"/>
@@ -119,11 +119,12 @@
   <!-- Build -->
   <target name="build" depends="import_ldapjdk,import_jss_jar">
     <!-- compile regular java code -->
     <javac srcdir="${java.src.dir}"
              destdir="${built.classdir}"
              debug="${compile.debug}" deprecation="${compile.deprecation}"
              optimize="${compile.optimize}"
              verbose="no"
+	      fork="true"
              excludes="**/CVS/**">
              <classpath refid="consolesdk.classpath" />
     </javac>
Index: src/com/netscape/management/client/console/Console.java
===================================================================
RCS file: /cvs/dirsec/console/src/com/netscape/management/client/console/Console.java,v
retrieving revision 1.1.1.1
diff -u -r1.1.1.1 Console.java
--- src/com/netscape/management/client/console/Console.java	18 Jul 2005 00:34:14 -0000	1.1.1.1
+++ src/com/netscape/management/client/console/Console.java	12 Oct 2005 20:25:02 -0000
@@ -28,8 +28,6 @@
 import java.net.MalformedURLException;
 
 import javax.swing.*;
-import javax.swing.event.*;
-import javax.swing.border.*;
 
 import com.netscape.management.nmclf.*;
 import com.netscape.management.client.*;
@@ -150,7 +148,7 @@
 
             if (!_useJavaLookAndFeel) {
                 SuiLookAndFeel nmclf = new SuiLookAndFeel();
-                UIManager.setLookAndFeel(nmclf);
+                UIManager.setLookAndFeel((LookAndFeel) nmclf);
 
                 // With JDK1.4 on Unix, the first instance of JFileChooser
                 // has an incorrect layout for some of the buttons. Create
Index: src/com/netscape/management/nmclf/SuiLookAndFeel.java
===================================================================
RCS file: /cvs/dirsec/console/src/com/netscape/management/nmclf/SuiLookAndFeel.java,v
retrieving revision 1.1.1.1
diff -u -r1.1.1.1 SuiLookAndFeel.java
--- src/com/netscape/management/nmclf/SuiLookAndFeel.java	18 Jul 2005 00:34:28 -0000	1.1.1.1
+++ src/com/netscape/management/nmclf/SuiLookAndFeel.java	12 Oct 2005 20:25:02 -0000
@@ -24,15 +24,9 @@
 import javax.swing.*;
 import javax.swing.border.*;
 import javax.swing.plaf.basic.*;
-import com.sun.java.swing.plaf.windows.*;
+import javax.swing.plaf.metal.*;
 import javax.swing.plaf.*;
-import javax.swing.text.JTextComponent;
-import javax.swing.text.DefaultEditorKit;
-import java.awt.event.KeyEvent;
-import java.awt.event.InputEvent;
-import java.util.*;
 
-import java.net.URL;
 import java.io.Serializable;
 
 import com.netscape.management.client.util.*;
@@ -49,7 +43,7 @@
  * @author Ben fry
  * @author Andy Hakim
  */
-public class SuiLookAndFeel extends WindowsLookAndFeel implements Serializable, SuiConstants 
+public class SuiLookAndFeel extends MetalLookAndFeel implements Serializable, SuiConstants 
 {
     public static final boolean _isWindows =
             System.getProperty("os.name").startsWith("Windows");
Index: src/com/netscape/management/nmclf/SuiTreeUI.java
===================================================================
RCS file: /cvs/dirsec/console/src/com/netscape/management/nmclf/SuiTreeUI.java,v
retrieving revision 1.1.1.1
diff -u -r1.1.1.1 SuiTreeUI.java
--- src/com/netscape/management/nmclf/SuiTreeUI.java	18 Jul 2005 00:34:28 -0000	1.1.1.1
+++ src/com/netscape/management/nmclf/SuiTreeUI.java	12 Oct 2005 20:25:02 -0000
@@ -20,16 +20,11 @@
 package com.netscape.management.nmclf;
 
 import java.awt.*;
-import java.awt.event.*;
-
-import java.io.*;
-import java.util.*;
 
 import javax.swing.*;
 import javax.swing.plaf.*;
 import javax.swing.tree.*;
 import javax.swing.plaf.basic.*;
-import com.sun.java.swing.plaf.windows.*;
 
 /**
  * A UI for JTree.  The original intent was to use curved lines