--- i2.log	2007-03-01 16:51:01.000000000 -0500
+++ i2a.log	2007-03-01 16:50:59.000000000 -0500
@@ -26,7 +26,6 @@
  gnome-themes            noarch     2.16.3-1.fc6     lcdr_c6_upd       2.5 M
  gnome-utils             i386       1:2.16.0-1.fc6   lcdr_c6           3.7 M
  grub                    i386       0.97-13          lcdr_c6           489 k
- kernel                  i686       2.6.19-1.2895.fc6  lcdr_c6_upd        16 M
  man                     i386       1.6d-2.fc6       lcdr_c6_upd       263 k
  nautilus                i386       2.16.2-7.fc6     lcdr_c6_upd       4.2 M
  nautilus-open-terminal  i386       0.7-3.fc6        lcdr_e6            34 k
@@ -52,9 +51,11 @@
  yum-updatesd            noarch     3.0.3-1.fc6      lcdr_c6_upd        20 k
 Installing for dependencies:
  GConf2                  i386       2.14.0-8.fc6     lcdr_c6_upd       1.5 M
+ MAKEDEV                 i386       3.23-1.2         lcdr_c6           135 k
  NetworkManager          i386       1:0.6.4-5.fc6    lcdr_c6           397 k
  ORBit2                  i386       2.14.3-4.fc6     lcdr_c6_upd       253 k
  PyXML                   i386       0.8.4-4          lcdr_c6           1.1 M
+ SysVinit                i386       2.86-14          lcdr_c6           112 k
  Xaw3d                   i386       1.5E-10.1        lcdr_c6           151 k
  alsa-lib                i386       1.0.13-1.fc6     lcdr_c6_upd       403 k
  aspell                  i386       12:0.60.3-7.1    lcdr_c6           940 k
@@ -63,44 +64,65 @@
  atk                     i386       1.12.2-1.fc6     lcdr_c6           222 k
  audiofile               i386       1:0.2.6-5        lcdr_c6           107 k
  audit                   i386       1.4.2-2.fc6      lcdr_c6_upd       230 k
+ audit-libs              i386       1.4.2-2.fc6      lcdr_c6_upd        57 k
  audit-libs-python       i386       1.4.2-2.fc6      lcdr_c6_upd        73 k
  avahi                   i386       0.6.16-2.fc6     lcdr_c6_upd       249 k
  avahi-glib              i386       0.6.16-2.fc6     lcdr_c6_upd        14 k
+ basesystem              noarch     8.0-5.1.1        lcdr_c6           2.8 k
+ bash                    i386       3.1-16.1         lcdr_c6           1.8 M
  beecrypt                i386       4.1.2-10.1.1     lcdr_c6           116 k
  bluez-gnome             i386       0.6-1.fc6        lcdr_c6_upd        30 k
  bluez-libs              i386       3.7-1            lcdr_c6            54 k
  bluez-utils             i386       3.7-2            lcdr_c6_upd       347 k
  bzip2                   i386       1.0.3-6.fc6      lcdr_c6_upd        49 k
+ bzip2-libs              i386       1.0.3-6.fc6      lcdr_c6_upd        37 k
  cairo                   i386       1.2.6-1.fc6      lcdr_c6_upd       406 k
  cdparanoia-libs         i386       alpha9.8-27.2    lcdr_c6            50 k
  cdrdao                  i386       1.2.1-2          lcdr_c6           440 k
  cdrecord                i386       9:2.01-10        lcdr_c6           590 k
+ chkconfig               i386       1.3.30-1         lcdr_c6           152 k
  chkfontpath             i386       1.10.1-1.1       lcdr_c6            15 k
  comps-extras            noarch     11.1-1.1         lcdr_c6            46 k
  control-center          i386       1:2.16.3-11.fc6  lcdr_c6_upd       2.7 M
+ coreutils               i386       5.97-12.3.fc6    lcdr_c6_upd       3.6 M
+ cpio                    i386       2.6-21.fc6       lcdr_c6_upd       126 k
+ cpp                     i386       4.1.1-51.fc6     lcdr_c6_upd       2.6 M
+ cracklib                i386       2.8.9-3.1        lcdr_c6            58 k
+ cracklib-dicts          i386       2.8.9-3.1        lcdr_c6           3.3 M
  cryptsetup-luks         i386       1.0.3-2.1        lcdr_c6           598 k
  cups                    i386       1:1.2.7-1.8.fc6  lcdr_c6_upd       2.8 M
  cups-libs               i386       1:1.2.7-1.8.fc6  lcdr_c6_upd       181 k
  cyrus-sasl-lib          i386       2.1.22-4         lcdr_c6_upd       127 k
+ db4                     i386       4.3.29-9.fc6     lcdr_c6           916 k
  dbus                    i386       1.0.1-9.fc6      lcdr_c6_upd       471 k
  dbus-glib               i386       0.70-6.fc6       lcdr_c6_upd       152 k
  dbus-python             i386       0.70-6           lcdr_c6           161 k
  dbus-x11                i386       1.0.1-9.fc6      lcdr_c6_upd        28 k
  desktop-backgrounds-basic  noarch     2.0-37           lcdr_c6           2.6 M
  desktop-file-utils      i386       0.10-7           lcdr_c6            59 k
+ device-mapper           i386       1.02.13-1.fc6    lcdr_c6_upd       561 k
  dhcdbd                  i386       2.1-1.fc6        lcdr_c6            58 k
  dhclient                i386       12:3.0.5-1.fc6   lcdr_c6_upd       274 k
  diffutils               i386       2.8.1-15.2.2     lcdr_c6           210 k
  dmidecode               i386       1:2.7-1.26.1.fc6  lcdr_c6            61 k
+ dmraid                  i386       1.0.0.rc13-1.fc6  lcdr_c6           554 k
  docbook-dtds            noarch     1.0-30.1         lcdr_c6           677 k
  dvd+rw-tools            i386       7.0-0.fc6.4      lcdr_c6_upd       115 k
+ e2fsprogs               i386       1.39-7.fc6       lcdr_c6_upd       955 k
+ e2fsprogs-libs          i386       1.39-7.fc6       lcdr_c6_upd       113 k
  eel2                    i386       2.16.1-1.fc6     lcdr_c6_upd       368 k
  eject                   i386       2.1.5-4.1.fc6    lcdr_c6_upd        49 k
+ elfutils-libelf         i386       0.126-1.fc6      lcdr_c6_upd        53 k
  emacs-common            i386       21.4-17.3.fc6    lcdr_c6_upd        11 M
  esound                  i386       1:0.2.36-3       lcdr_c6           130 k
+ ethtool                 i386       3-1.2.2          lcdr_c6            55 k
  evolution-data-server   i386       1.8.3-1.fc6      lcdr_c6_upd       3.4 M
  expat                   i386       1.95.8-8.2.1     lcdr_c6            77 k
  fedora-logos            noarch     6.0.6-1.fc6      lcdr_c6           7.5 M
+ fedora-release          noarch     6-4              lcdr_c6            28 k
+ fedora-release-notes    noarch     6-3              lcdr_c6           765 k
+ filesystem              i386       2.4.0-1          lcdr_c6           116 k
+ findutils               i386       1:4.2.27-4.1     lcdr_c6           293 k
  firefox                 i386       1.5.0.10-1.fc6   lcdr_c6_upd        18 M
  flac                    i386       1.1.2-27         lcdr_c6           306 k
  fontconfig              i386       2.4.1-3.fc6      lcdr_c6           175 k
@@ -110,10 +132,15 @@
  fuse-libs               i386       2.6.3-2.fc6      lcdr_e6            57 k
  gail                    i386       1.9.2-1.fc6      lcdr_c6           353 k
  gamin                   i386       0.1.7-8.fc6      lcdr_c6_upd       119 k
+ gawk                    i386       3.1.5-14.fc6     lcdr_c6_upd       1.7 M
  gcalctool               i386       5.8.25-1.fc6     lcdr_c6_upd       1.0 M
+ gdbm                    i386       1.8.0-26.2.1     lcdr_c6            27 k
  ghostscript             i386       8.15.3-4.fc6     lcdr_c6_upd       5.9 M
  ghostscript-fonts       noarch     5.50-13.1.1      lcdr_c6           801 k
  giflib                  i386       4.1.3-7.1        lcdr_c6            39 k
+ glib2                   i386       2.12.9-1.fc6     lcdr_c6_upd       698 k
+ glibc                   i686       2.5-10.fc6       lcdr_c6_upd       5.1 M
+ glibc-common            i386       2.5-10.fc6       lcdr_c6_upd        16 M
  gnome-bluetooth-libs    i386       0.7.0-11.fc6     lcdr_c6_upd        65 k
  gnome-desktop           i386       2.16.3-1.fc6     lcdr_c6_upd       812 k
  gnome-doc-utils         noarch     0.8.0-2.fc6      lcdr_c6           252 k
@@ -143,6 +170,7 @@
  gnome-volume-manager    i386       2.15.0-4.fc6     lcdr_c6_upd       404 k
  gnutls                  i386       1.4.1-2          lcdr_c6           349 k
  gphoto2                 i386       2.3.1-3.fc6      lcdr_c6_upd       1.4 M
+ grep                    i386       2.5.1-54.1.2.fc6  lcdr_c6_upd       174 k
  groff                   i386       1.18.1.1-11.1    lcdr_c6           1.9 M
  gstreamer               i386       0.10.10-2.fc6    lcdr_c6_upd       552 k
  gstreamer-plugins-base  i386       0.10.10-1.fc6    lcdr_c6_upd       633 k
@@ -154,14 +182,24 @@
  gtkhtml2                i386       2.11.0-3         lcdr_c6           184 k
  gtksourceview           i386       1.8.0-1.fc6      lcdr_c6           461 k
  gucharmap               i386       1.8.0-1.fc6      lcdr_c6           2.4 M
+ gzip                    i386       1.3.5-9          lcdr_c6           100 k
  hal                     i386       0.5.8.1-6.fc6    lcdr_c6_upd       368 k
  hal-cups-utils          i386       0.6.5-1.fc6      lcdr_c6_upd        28 k
  hicolor-icon-theme      noarch     0.9-2.1          lcdr_c6            25 k
  htmlview                noarch     3.0.0-15.fc6     lcdr_c6_upd       8.2 k
  hwdata                  noarch     0.191-1          lcdr_c6           254 k
+ info                    i386       4.8-14.fc6       lcdr_c6_upd       172 k
+ initscripts             i386       8.45.7-1         lcdr_c6_upd       1.3 M
+ iproute                 i386       2.6.19-1.fc6     lcdr_c6_upd       811 k
+ iputils                 i386       20020927-41.fc6  lcdr_c6           158 k
  iso-codes               noarch     0.53-1           lcdr_c6           1.4 M
  kbd                     i386       1.12-18          lcdr_c6           1.0 M
+ kernel                  i686       2.6.19-1.2911.fc6  lcdr_c6_upd        16 M
+ kernel-headers          i386       2.6.19-1.2911.fc6  lcdr_c6_upd       701 k
+ kpartx                  i386       0.4.7-5          lcdr_c6           380 k
+ krb5-libs               i386       1.5-13           lcdr_c6_upd       590 k
  kudzu                   i386       1.2.57.6-1       lcdr_c6_upd       218 k
+ less                    i386       394-5.fc6        lcdr_c6_upd       100 k
  libFS                   i386       1.0.0-3.1        lcdr_c6            30 k
  libICE                  i386       1.0.1-2.1        lcdr_c6            53 k
  libIDL                  i386       0.8.7-1.fc6      lcdr_c6            85 k
@@ -194,11 +232,14 @@
  libXxf86dga             i386       1.0.1-3.1        lcdr_c6            15 k
  libXxf86misc            i386       1.0.1-3.1        lcdr_c6            12 k
  libXxf86vm              i386       1.0.1-3.1        lcdr_c6            14 k
+ libacl                  i386       2.2.39-1.1       lcdr_c6            19 k
  libart_lgpl             i386       2.3.17-4         lcdr_c6            76 k
+ libattr                 i386       2.4.32-1.1       lcdr_c6            12 k
  libavc1394              i386       0.5.3-1.fc6      lcdr_c6            45 k
  libbonobo               i386       2.16.0-1.fc6     lcdr_c6           501 k
  libbonoboui             i386       2.16.0-1.fc6     lcdr_c6           390 k
  libbtctl                i386       0.6.0-9.1        lcdr_c6            45 k
+ libcap                  i386       1.10-25          lcdr_c6            22 k
  libcroco                i386       0.6.1-2.1        lcdr_c6           127 k
  libdaemon               i386       0.10-3.2         lcdr_c6            24 k
  libdmx                  i386       1.0.2-3.1        lcdr_c6            13 k
@@ -207,6 +248,7 @@
  libexif                 i386       0.6.13-2         lcdr_c6           149 k
  libfontenc              i386       1.0.2-2.1        lcdr_c6            19 k
  libgail-gnome           i386       1.1.3-1.2.1      lcdr_c6            28 k
+ libgcc                  i386       4.1.1-51.fc6     lcdr_c6_upd        81 k
  libgcrypt               i386       1.2.3-1          lcdr_c6           174 k
  libglade2               i386       2.6.0-2          lcdr_c6            96 k
  libgnome                i386       2.16.0-4.fc6     lcdr_c6           858 k
@@ -227,9 +269,13 @@
  libpng                  i386       2:1.2.10-7       lcdr_c6           242 k
  libraw1394              i386       1.2.1-1.fc6      lcdr_c6            39 k
  librsvg2                i386       2.16.1-1.fc6     lcdr_c6_upd       179 k
+ libselinux              i386       1.33.4-2.fc6     lcdr_c6_upd        94 k
  libselinux-python       i386       1.33.4-2.fc6     lcdr_c6_upd        55 k
  libsemanage             i386       1.6.17-1         lcdr_c6           135 k
+ libsepol                i386       1.15.3-1.fc6     lcdr_c6_upd       129 k
  libsoup                 i386       2.2.99-1.fc6     lcdr_c6_upd       149 k
+ libstdc++               i386       4.1.1-51.fc6     lcdr_c6_upd       349 k
+ libtermcap              i386       2.0.8-46.1       lcdr_c6            14 k
  libtheora               i386       1.0alpha7-1      lcdr_c6           709 k
  libtiff                 i386       3.8.2-6.fc6      lcdr_c6           312 k
  libusb                  i386       0.1.12-5.1       lcdr_c6            27 k
@@ -244,13 +290,22 @@
  libxml2-python          i386       2.6.27-1.FC6     lcdr_c6_upd       705 k
  libxslt                 i386       1.1.20-1.fc6     lcdr_c6_upd       521 k
  lockdev                 i386       1.0.1-10         lcdr_c6            15 k
+ lvm2                    i386       2.02.17-1.fc6    lcdr_c6_upd       1.0 M
  lzo                     i386       2.02-2.fc6       lcdr_e6            63 k
+ mcstrans                i386       0.1.8-3          lcdr_c6            15 k
  mesa-libGL              i386       6.5.1-9.fc6      lcdr_c6_upd       9.7 M
  metacity                i386       2.16.5-1.fc6     lcdr_c6_upd       2.2 M
+ mingetty                i386       1.07-5.2.2       lcdr_c6            19 k
+ mkinitrd                i386       5.1.19.0.2-1     lcdr_c6_upd       438 k
  mkisofs                 i386       9:2.01-10        lcdr_c6           595 k
+ mktemp                  i386       3:1.5-23.2.2     lcdr_c6            14 k
+ module-init-tools       i386       3.3-0.pre1.4.17  lcdr_c6           399 k
+ nash                    i386       5.1.19.0.2-1     lcdr_c6_upd       1.1 M
  nautilus-cd-burner      i386       2.16.3-1.fc6     lcdr_c6_upd       476 k
  nautilus-extensions     i386       2.16.2-7.fc6     lcdr_c6_upd        38 k
+ ncurses                 i386       5.5-24.20060715  lcdr_c6           1.1 M
  neon                    i386       0.25.5-5.1       lcdr_c6            96 k
+ net-tools               i386       1.60-73          lcdr_c6           359 k
  newt                    i386       0.52.2-9         lcdr_c6           107 k
  notification-daemon     i386       0.3.6-1.fc6      lcdr_c6_upd        51 k
  notify-python           i386       0.1.0-3.fc6      lcdr_c6            12 k
@@ -262,25 +317,34 @@
  openobex                i386       1.3-3.1          lcdr_c6            21 k
  opensp                  i386       1.5.2-3.1        lcdr_c6           1.1 M
  openssh                 i386       4.3p2-14.fc6     lcdr_c6_upd       278 k
+ openssl                 i686       0.9.8b-8.3.fc6   lcdr_c6_upd       1.4 M
  openvpn                 i386       2.1-0.14.beta16.fc6  lcdr_e6           357 k
+ pam                     i386       0.99.6.2-3.16.fc6  lcdr_c6_upd       924 k
  pango                   i386       1.14.10-1.fc6    lcdr_c6_upd       333 k
  paps                    i386       0.6.6-17.fc6     lcdr_c6_upd        32 k
  passwd                  i386       0.73-1           lcdr_c6            20 k
  pciutils                i386       2.2.3-4          lcdr_c6            82 k
+ pcre                    i386       6.6-1.1          lcdr_c6           111 k
+ perl                    i386       4:5.8.8-10       lcdr_c6            12 M
  pkgconfig               i386       1:0.21-1.fc6     lcdr_c6            58 k
  pm-utils                i386       0.19-3           lcdr_c6            42 k
  policycoreutils         i386       1.34.1-4.fc6     lcdr_c6_upd       474 k
  poppler                 i386       0.5.4-5.fc6      lcdr_c6_upd       3.0 M
+ popt                    i386       1.10.2-32        lcdr_c6            67 k
+ procps                  i386       3.2.7-8.2.fc6    lcdr_c6_upd       207 k
+ psmisc                  i386       22.2-5           lcdr_c6            61 k
  pycairo                 i386       1.2.6-1.fc6      lcdr_c6_upd        27 k
  pygobject2              i386       2.12.3-1.fc6     lcdr_c6_upd        98 k
  pygtk2                  i386       2.10.4-1.fc6     lcdr_c6_upd       1.1 M
  pygtk2-libglade         i386       2.10.4-1.fc6     lcdr_c6_upd        18 k
  pyorbit                 i386       2.14.1-1.1       lcdr_c6            48 k
+ python                  i386       2.4.4-1.fc6      lcdr_c6_upd       5.9 M
  python-elementtree      i386       1.2.6-5          lcdr_c6            84 k
  python-numeric          i386       24.2-1.fc6       lcdr_c6_upd       755 k
  python-sqlite           i386       1.1.7-1.2.1      lcdr_c6            39 k
  python-urlgrabber       noarch     2.9.9-2          lcdr_c6           124 k
  pyxf86config            i386       0.3.31-2.fc6     lcdr_c6            65 k
+ readline                i386       5.1-1.1          lcdr_c6           223 k
  redhat-artwork          i386       5.0.8-4.fc6      lcdr_c6_upd       5.3 M
  redhat-menus            noarch     6.7.8-2.fc6      lcdr_c6_upd       203 k
  rhpl                    i386       0.194-1          lcdr_c6           242 k
@@ -290,19 +354,28 @@
  rpm-python              i386       4.4.2-32         lcdr_c6            52 k
  samba-common            i386       3.0.24-1.fc6     lcdr_c6_upd       8.6 M
  scrollkeeper            i386       0.3.14-8.fc6     lcdr_c6           294 k
+ sed                     i386       4.1.5-5.fc6      lcdr_c6           175 k
  selinux-policy          noarch     2.4.6-40.fc6     lcdr_c6_upd       350 k
+ setup                   noarch     2.6.1.1-1.fc6    lcdr_c6_upd       126 k
  sgml-common             noarch     0.6.3-18         lcdr_c6            40 k
+ shadow-utils            i386       2:4.0.17-12.fc6  lcdr_c6_upd       1.0 M
  shared-mime-info        i386       0.19-1           lcdr_c6           147 k
  slang                   i386       2.0.7-1.fc6      lcdr_c6_upd       328 k
  speex                   i386       1.2-0.1.beta1.fc6  lcdr_c6_upd       475 k
  sqlite                  i386       3.3.6-2          lcdr_c6           213 k
  startup-notification    i386       0.8-4.1          lcdr_c6            32 k
+ sysklogd                i386       1.4.1-41.fc6     lcdr_c6_upd        73 k
  system-config-printer-libs  i386       0.7.52-1.fc6     lcdr_c6_upd       258 k
+ tar                     i386       2:1.15.1-24.fc6  lcdr_c6_upd       750 k
+ termcap                 noarch     1:5.5-1.20060701.1  lcdr_c6           265 k
  tmpwatch                i386       2.9.7-1.1        lcdr_c6            18 k
  totem                   i386       2.16.5-1.fc6     lcdr_c6_upd       1.9 M
  ttmkfdir                i386       3.0.9-22         lcdr_c6            45 k
+ tzdata                  noarch     2007c-1.fc6      lcdr_c6_upd       753 k
+ udev                    i386       095-17.fc6       lcdr_c6_upd       877 k
  urw-fonts               noarch     2.3-6.1.1        lcdr_c6           4.5 M
  usermode                i386       1.87-3           lcdr_c6           150 k
+ util-linux              i386       2.13-0.46.fc6    lcdr_c6_upd       1.8 M
  vim-minimal             i386       2:7.0.191-2.fc6  lcdr_c6_upd       346 k
  vpnc                    i386       0.3.3-13.fc6     lcdr_e6            49 k
  vte                     i386       0.14.2-1.fc6     lcdr_c6_upd       459 k
@@ -386,11 +459,12 @@
  yum                     noarch     3.0.3-1.fc6      lcdr_c6_upd       482 k
  yum-metadata-parser     i386       1.0.3-1.fc6      lcdr_c6_upd        23 k
  zenity                  i386       2.16.3-1.fc6     lcdr_c6_upd       1.3 M
+ zlib                    i386       1.2.3-3          lcdr_c6            50 k
 
 Transaction Summary
 =============================================================================
-Install    383 Package(s)         
+Install    457 Package(s)         
 Update       0 Package(s)         
 Remove       0 Package(s)         
 
-Total download size: 262 M
+Total download size: 338 M